// modules are defined as an array
// [ module function, map of requires ]
//
// map of requires is short require name -> numeric require
//
// anything defined in a previous bundle is accessed via the
// orig method which is the require for previous bundles
parcelRequire = (function (modules, cache, entry, globalName) {
  // Save the require from previous bundle to this closure if any
  var previousRequire = typeof parcelRequire === 'function' && parcelRequire;
  var nodeRequire = typeof require === 'function' && require;

  function newRequire(name, jumped) {
    if (!cache[name]) {
      if (!modules[name]) {
        // if we cannot find the module within our internal map or
        // cache jump to the current global require ie. the last bundle
        // that was added to the page.
        var currentRequire = typeof parcelRequire === 'function' && parcelRequire;
        if (!jumped && currentRequire) {
          return currentRequire(name, true);
        }

        // If there are other bundles on this page the require from the
        // previous one is saved to 'previousRequire'. Repeat this as
        // many times as there are bundles until the module is found or
        // we exhaust the require chain.
        if (previousRequire) {
          return previousRequire(name, true);
        }

        // Try the node require function if it exists.
        if (nodeRequire && typeof name === 'string') {
          return nodeRequire(name);
        }

        var err = new Error('Cannot find module \'' + name + '\'');
        err.code = 'MODULE_NOT_FOUND';
        throw err;
      }

      localRequire.resolve = resolve;
      localRequire.cache = {};

      var module = cache[name] = new newRequire.Module(name);

      modules[name][0].call(module.exports, localRequire, module, module.exports, this);
    }

    return cache[name].exports;

    function localRequire(x){
      return newRequire(localRequire.resolve(x));
    }

    function resolve(x){
      return modules[name][1][x] || x;
    }
  }

  function Module(moduleName) {
    this.id = moduleName;
    this.bundle = newRequire;
    this.exports = {};
  }

  newRequire.isParcelRequire = true;
  newRequire.Module = Module;
  newRequire.modules = modules;
  newRequire.cache = cache;
  newRequire.parent = previousRequire;
  newRequire.register = function (id, exports) {
    modules[id] = [function (require, module) {
      module.exports = exports;
    }, {}];
  };

  var error;
  for (var i = 0; i < entry.length; i++) {
    try {
      newRequire(entry[i]);
    } catch (e) {
      // Save first error but execute all entries
      if (!error) {
        error = e;
      }
    }
  }

  if (entry.length) {
    // Expose entry point to Node, AMD or browser globals
    // Based on https://github.com/ForbesLindesay/umd/blob/master/template.js
    var mainExports = newRequire(entry[entry.length - 1]);

    // CommonJS
    if (typeof exports === "object" && typeof module !== "undefined") {
      module.exports = mainExports;

    // RequireJS
    } else if (typeof define === "function" && define.amd) {
     define(function () {
       return mainExports;
     });

    // <script>
    } else if (globalName) {
      this[globalName] = mainExports;
    }
  }

  // Override the current require with this new one
  parcelRequire = newRequire;

  if (error) {
    // throw error from earlier, _after updating parcelRequire_
    throw error;
  }

  return newRequire;
})({"OTDD":[function(require,module,exports) {
module.exports = "ball-red.9c05783f.png";
},{}],"jTHS":[function(require,module,exports) {
module.exports = "ball-gold.ac17adf9.png";
},{}],"hmvU":[function(require,module,exports) {
module.exports = "ball-purple.de9a001c.png";
},{}],"Focm":[function(require,module,exports) {
"use strict";

var _ballRed = _interopRequireDefault(require("./images/ball-red.png"));

var _ballGold = _interopRequireDefault(require("./images/ball-gold.png"));

var _ballPurple = _interopRequireDefault(require("./images/ball-purple.png"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var native = function native(method) {
  var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  if (window.android && window.android[method]) {
    window.android[method](params);
  }

  if (window.webkit && window.webkit.messageHandlers && window.webkit.messageHandlers[method]) {
    window.webkit.messageHandlers[method].postMessage(params);
  }

  return false;
};

var DAMPING = 0.7,
    // 阻尼
GRAVITY = 0.6,
    // 重力
SPEED = 1; // 速度

var MOUSE_SIZE = 30;
var playing = false;

var Ball = /*#__PURE__*/function () {
  function Ball(_ref) {
    var x = _ref.x,
        y = _ref.y,
        ratio = _ref.ratio,
        rotate = _ref.rotate,
        radius = _ref.radius;

    _classCallCheck(this, Ball);

    this.x = x;
    this.y = y;
    this.px = x;
    this.py = y;
    this.fx = 0;
    this.fy = 0;
    this.radius = radius;
    this.rotate = rotate;
    this.ratio = ratio;
  } // 作用力


  _createClass(Ball, [{
    key: "apply_force",
    value: function apply_force(delta) {
      delta *= delta;
      this.fy += GRAVITY;
      this.x += this.fx * delta;
      this.y += this.fy * delta;
      this.fx = this.fy = 0;
    }
  }, {
    key: "verlet",
    value: function verlet() {
      var nx = this.x * 2 - this.px;
      var ny = this.y * 2 - this.py;
      this.px = this.x;
      this.py = this.y;
      this.x = nx;
      this.y = ny;
    }
  }, {
    key: "draw",
    value: function draw(context, img) {
      var x = this.x,
          y = this.y,
          rotate = this.rotate,
          radius = this.radius;
      context.save();
      context.translate(x, y);
      context.rotate(rotate);
      context.drawImage(img, -radius, -radius, radius * 2, radius * 2);
      context.translate(-x, -y);
      context.restore();
    }
  }]);

  return Ball;
}();

var LotteryMachine = /*#__PURE__*/function () {
  function LotteryMachine() {
    var opt = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, LotteryMachine);

    var ratio = 2;
    var def = {
      id: 'balls',
      width: window.innerWidth,
      ratio: ratio,
      count: 12,
      // 球的个数
      size: 18 / (ratio / 2),
      // 球的大小
      colors: ['#c15bb6', '#8380c3', '#ffde7f', '#ff8f03', '#ec5767', '#ff8085']
    };
    this.ratio = 2;
    this.playing = false;
    this.stick = {
      x: 0,
      y: 0,
      angle: Math.PI * 360 / 180,
      speed: 16
    };
    this.requestID = null;
    this.opt = Object.assign({}, def, opt);
    this.balls = [];
    this.obstacles = [];
    this.init();
  }

  _createClass(LotteryMachine, [{
    key: "init",
    value: function init() {
      var _this = this;

      // 初始化画布
      var _this$opt = this.opt,
          id = _this$opt.id,
          ratio = _this$opt.ratio,
          count = _this$opt.count,
          width = _this$opt.width;
      var canvas = document.getElementById(id);
      this.canvas = canvas;
      this.canvas.width = width;
      this.canvas.height = width;
      this.context = canvas.getContext('2d');
      this.context.scale(ratio, ratio);
      this.context.save(); // 创建球

      this.balls = new Array(Math.abs(count)).fill(0).map(function (item) {
        return _this.createBall();
      });
      this.createObstacles(); // 加载资源

      this.loadResources();
      return this;
    }
  }, {
    key: "loadResources",
    value: function loadResources() {
      var _this2 = this;

      Promise.all([this.loadBall(_ballRed.default), this.loadBall(_ballGold.default), this.loadBall(_ballPurple.default)]).then(function (images) {
        _this2.redBall = images[0];
        _this2.goldBall = images[1];
        _this2.purpleBall = images[2];

        _this2.animate();
      });
    }
  }, {
    key: "play",
    value: function play() {
      this.playing = true;
    }
  }, {
    key: "stop",
    value: function stop() {
      this.playing = false;
    } // 创建球体

  }, {
    key: "createBall",
    value: function createBall() {
      var pos = this.getBallPosition();
      return new Ball(pos);
    }
  }, {
    key: "animate",
    value: function animate() {
      this.requestID = window.requestAnimationFrame(this.animate.bind(this));
      var balls = this.balls,
          playing = this.playing;
      var iter = 6;
      var delta = SPEED / iter;

      while (iter--) {
        var i = balls.length;

        while (i--) {
          balls[i].apply_force(delta);
          balls[i].verlet();
        }

        this.resolveCollisions();
        this.checkWalls();
        var j = balls.length;

        while (j--) {
          balls[j].verlet();
        }

        this.resolveCollisions(1);
        this.checkWalls();
      }

      this.drawBalls();
      playing && this.mixing();
    }
  }, {
    key: "loadBall",
    value: function loadBall(src) {
      return new Promise(function (resolve, reject) {
        var image = new Image();

        image.onload = function (e) {
          resolve(image);
        };

        image.src = src;
      });
    }
  }, {
    key: "drawBalls",
    value: function drawBalls() {
      var balls = this.balls,
          context = this.context,
          redBall = this.redBall,
          goldBall = this.goldBall,
          purpleBall = this.purpleBall;
      var width = this.opt.width;
      var i = balls.length;
      context.clearRect(0, 0, width, width);

      while (i--) {
        if (0 <= i < 4) {
          balls[i].draw(context, redBall);
        }

        if (4 <= i < 8) {
          balls[i].draw(context, goldBall);
        }

        if (8 <= i) {
          balls[i].draw(context, purpleBall);
        }
      }
    }
  }, {
    key: "drawObstacles",
    value: function drawObstacles() {
      var context = this.context,
          obstacles = this.obstacles;
      var i = obstacles.length;
      context.fillStyle = 'rgba(27,155,244,0.3)';

      while (i--) {
        var obstacle = obstacles[i];
        context.fillStyle = 'rgba(0,0,0,0.1)';
        context.strokeStyle = 'rgba(0,0,0,0.2)';
        context.beginPath();
        context.arc(obstacle.x, obstacle.y, obstacle.radius, 0, Math.PI * 2);
        context.fill();
        context.stroke();
      }
    }
  }, {
    key: "createObstacles",
    value: function createObstacles() {
      var canvas = this.canvas,
          ratio = this.ratio;
      var radius = canvas.width / ratio / 2;

      for (var i = 0; i < 180; i++) {
        var angle = Math.PI * i * 2 / 180;
        var size = 4;
        var y = Math.sin(angle) * (radius + size / 2) + radius;
        var x = Math.cos(angle) * (radius + size / 2) + radius;
        this.obstacles.push({
          x: x,
          y: y,
          radius: size
        });
      }
    } // 搅动

  }, {
    key: "mixing",
    value: function mixing() {
      var stick = this.stick,
          canvas = this.canvas;

      if (stick.x <= 0) {
        this.stick.speed = 16;
      }

      if (stick.x >= canvas.width / 2) {
        this.stick.speed = -16;
      }

      this.stick.x = stick.x + stick.speed;
      this.stick.y = canvas.width / 2;
    } // 碰撞检测

  }, {
    key: "resolveCollisions",
    value: function resolveCollisions(ip) {
      var balls = this.balls,
          playing = this.playing,
          stick = this.stick,
          canvas = this.canvas,
          obstacles = this.obstacles;
      var i = balls.length;

      while (i--) {
        var ball_1 = balls[i];

        if (playing) {
          var diff_x = ball_1.x - stick.x;
          var diff_y = ball_1.y - stick.y;
          var dist = Math.sqrt(diff_x * diff_x + diff_y * diff_y);
          var real_dist = dist - (ball_1.radius + MOUSE_SIZE);

          if (real_dist < 0) {
            var depth_x = diff_x * (real_dist / dist);
            var depth_y = diff_y * (real_dist / dist);
            ball_1.x -= depth_x * 0.005;
            ball_1.y -= depth_y * 0.005;
          }
        } // 障碍物


        var k = obstacles.length;

        while (k--) {
          var obstacle = obstacles[k];

          var _diff_x = ball_1.x - obstacle.x;

          var _diff_y = ball_1.y - obstacle.y;

          var _dist = Math.sqrt(_diff_x * _diff_x + _diff_y * _diff_y);

          var _real_dist = _dist - (ball_1.radius + obstacle.radius);

          if (_real_dist < 0) {
            var _depth_x = _diff_x * (_real_dist / _dist);

            var _depth_y = _diff_y * (_real_dist / _dist);

            ball_1.x -= _depth_x * 0.005;
            ball_1.y -= _depth_y * 0.005;
          }
        }

        var n = balls.length;

        while (n--) {
          if (n == i) continue;
          var ball_2 = balls[n];

          var _diff_x2 = ball_1.x - ball_2.x;

          var _diff_y2 = ball_1.y - ball_2.y;

          var length = _diff_x2 * _diff_x2 + _diff_y2 * _diff_y2;

          var _dist2 = Math.sqrt(length);

          var _real_dist2 = _dist2 - (ball_1.radius + ball_2.radius);

          if (_real_dist2 < 0) {
            var vel_x1 = ball_1.x - ball_1.px;
            var vel_y1 = ball_1.y - ball_1.py;
            var vel_x2 = ball_2.x - ball_2.px;
            var vel_y2 = ball_2.y - ball_2.py;

            var _depth_x2 = _diff_x2 * (_real_dist2 / _dist2);

            var _depth_y2 = _diff_y2 * (_real_dist2 / _dist2);

            ball_1.x -= _depth_x2 * 0.5;
            ball_1.y -= _depth_y2 * 0.5;
            ball_2.x += _depth_x2 * 0.5;
            ball_2.y += _depth_y2 * 0.5;

            if (ip) {
              var pr1 = DAMPING * (_diff_x2 * vel_x1 + _diff_y2 * vel_y1) / length,
                  pr2 = DAMPING * (_diff_x2 * vel_x2 + _diff_y2 * vel_y2) / length;
              vel_x1 += pr2 * _diff_x2 - pr1 * _diff_x2;
              vel_x2 += pr1 * _diff_x2 - pr2 * _diff_x2;
              vel_y1 += pr2 * _diff_y2 - pr1 * _diff_y2;
              vel_y2 += pr1 * _diff_y2 - pr2 * _diff_y2;
              ball_1.px = ball_1.x - vel_x1;
              ball_1.py = ball_1.y - vel_y1;
              ball_2.px = ball_2.x - vel_x2;
              ball_2.py = ball_2.y - vel_y2;
            }
          }
        }
      }
    } // 检测边界

  }, {
    key: "checkWalls",
    value: function checkWalls() {
      var balls = this.balls,
          canvas = this.canvas;
      var i = balls.length;

      while (i--) {
        var ball = balls[i];

        if (ball.x < ball.radius) {
          var vel_x = ball.px - ball.x;
          ball.x = ball.radius;
          ball.px = ball.x - vel_x * DAMPING;
        } else if (ball.x + ball.radius > canvas.width / 2) {
          var _vel_x = ball.px - ball.x;

          ball.x = canvas.width / 2 - ball.radius;
          ball.px = ball.x - _vel_x * DAMPING;
        }

        if (ball.y < ball.radius) {
          var vel_y = ball.py - ball.y;
          ball.y = ball.radius;
          ball.py = ball.y - vel_y * DAMPING;
        } else if (ball.y + ball.radius > canvas.height / 2) {
          var _vel_y = ball.py - ball.y;

          ball.y = canvas.height / 2 - ball.radius;
          ball.py = ball.y - _vel_y * DAMPING;
        }
      }
    } // 生成球的位置信息

  }, {
    key: "getBallPosition",
    value: function getBallPosition() {
      var angle = Math.PI * Math.random() * 360 / 180;
      var randomShift = 0;
      var _this$opt2 = this.opt,
          width = _this$opt2.width,
          size = _this$opt2.size,
          ratio = _this$opt2.ratio;
      var radius = width / ratio / 2;
      var y = Math.sin(angle) * (radius - size / 2) + radius + randomShift;
      var x = Math.cos(angle) * (radius - size / 2) + radius + randomShift;
      return {
        x: x,
        y: y,
        rotate: Math.PI * Math.random() * 360 / 180,
        ratio: 2,
        radius: size / 2
      };
    }
  }]);

  return LotteryMachine;
}();

var lotteryMachine = new LotteryMachine();
var award = document.querySelector('.award');
var one = document.querySelector('.one');
one.addEventListener('click', function () {
  if (!playing) {
    native('starLottery', 1);
  }
}, false);
var ten = document.querySelector('.ten');
ten.addEventListener('click', function () {
  if (!playing) {
    native('starLottery', 10);
  }
}, false);

window.startAnimation = function () {
  var num = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;

  if (playing) {
    return false;
  }

  playing = true;
  award.classList.remove('rolling');
  lotteryMachine.play();

  if (num == 1) {
    one.disabled = true;
  } else {
    ten.disabled = true;
  }
};

window.stopAnimation = function (rolled) {
  playing = false;
  var btns = document.getElementsByTagName('button');

  if (rolled) {
    award.classList.add('rolling');
  }

  for (var i = 0; i < btns.length; i++) {
    btns[i].disabled = false;
  }

  lotteryMachine.stop();
};
},{"./images/ball-red.png":"OTDD","./images/ball-gold.png":"jTHS","./images/ball-purple.png":"hmvU"}]},{},["Focm"], null)